"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const path = __importStar(require("path"));
const assert = __importStar(require("assert"));
const R = __importStar(require("ramda"));
const lib_1 = require("@mand-mobile/platform-builder/lib");
const builtin_plugins_1 = require("@mand-mobile/platform-builder/lib/builtin-plugins");
const validTargets = new Set(['lib', 'sfc', 'bundle']);
module.exports = (api) => (args) => __awaiter(void 0, void 0, void 0, function* () {
    const targetTable = {
        'lib': (options = {}) => [builtin_plugins_1.VueifySFCBuilderPlugin, options],
        'sfc': (options = {}) => [builtin_plugins_1.VueSFCBuilderPlugin, options],
        'bundle': (options = {}) => [builtin_plugins_1.RollupBuilderPlugin, options],
    };
    // const config = api.resolveWebpackConfig()
    const plugins = [];
    assert.strictEqual(typeof args.output === 'string', true, 'output must be a dist path');
    if (args.platform) {
        plugins.push([builtin_plugins_1.PlatformSetupPlugin, { platform: args.platform, removePlatformExt: ['lib', 'sfc'].includes(args.target) }]);
    }
    if (args.transformCss === true) {
        assert.strictEqual((['lib', 'sfc'].includes(args.target)), true, 'transformCss options must set in sfc mode');
    }
    if (args.target) {
        assert.strictEqual(validTargets.has(args.target), true, 'build target must in [lib, sfc, bundle]');
        plugins.push(targetTable[args.target]({ transformCss: args.transformCss }));
    }
    let themeOptions = {};
    if (!args.theme) {
        themeOptions.theme = args.theme;
    }
    if (args.unit) {
        themeOptions.unit = args.unit;
    }
    plugins.push([builtin_plugins_1.ThemeSetupPlugin, themeOptions]);
    plugins.push([builtin_plugins_1.ComponentsSourceSetupPlugin, {
            namedAs: 'mand-mobile'
        }]);
    const c = new lib_1.BuilderContainer({
        // 暂时使用一个唯一的时间戳用于创建临时文件，防并发使用随机数前缀
        outputRoot: path.resolve(process.cwd(), `__temp__/${R.compose((item) => item.toString(), Math.floor, (num) => num * 100, Math.random)()}-${+(new Date())}`),
        artifactRoot: path.resolve(process.cwd(), args.output),
        plugins,
    });
    yield c.create();
    yield c.build();
    c.destory();
});
//# sourceMappingURL=index.js.map