"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const path = __importStar(require("path"));
const assert = __importStar(require("assert"));
const platform_builder_1 = require("@mand-mobile/platform-builder");
const builtin_plugins_1 = require("@mand-mobile/platform-builder/lib/builtin-plugins");
const R = __importStar(require("ramda"));
module.exports = (api) => (args) => __awaiter(void 0, void 0, void 0, function* () {
    // const config = api.resolveWebpackConfig()
    const plugins = [];
    let themeOptions = {};
    if (!args.theme) {
        themeOptions.theme = args.theme;
    }
    plugins.push([builtin_plugins_1.ThemeSetupPlugin, themeOptions]);
    plugins.push([builtin_plugins_1.ComponentsSourceSetupPlugin, {
            namedAs: 'mand-mobile',
            watched: args.watch,
        }]);
    if (args.platform) {
        plugins.push([builtin_plugins_1.PlatformSetupPlugin, {
                platform: args.platform,
                removePlatformExt: ['lib', 'sfc'].includes(args.target),
                watched: args.watch,
            }]);
        if (args.platform === 'uni') {
            assert.strictEqual(typeof args.output === 'string', true, 'output must be a dist path');
            plugins.push([builtin_plugins_1.VueCliBuilderUniPlugin, {
                    single: args.single,
                    watched: args.watch,
                    componentName: args['component-name'],
                }]);
        }
        if (args.platform === 'web') {
            args.output = args.output || '';
            plugins.push([builtin_plugins_1.VueCliBuilderPlugin, {
                    single: args.single,
                    watched: args.watch,
                    componentName: args['component-name'],
                }]);
        }
    }
    const c = new platform_builder_1.BuilderContainer({
        // 暂时使用一个唯一的时间戳用于创建临时文件，防并发使用随机数前缀
        outputRoot: path.resolve(process.cwd(), `__temp__/${R.compose((item) => item.toString(), Math.floor, (num) => num * 100, Math.random)()}-${+(new Date())}`),
        artifactRoot: path.resolve(process.cwd(), args.output),
        plugins,
    });
    yield c.create();
    yield c.serve();
    process.on('exit', () => __awaiter(void 0, void 0, void 0, function* () {
        // 进程退出前自动清理构建产物
        return c.destory();
    }));
});
//# sourceMappingURL=index.js.map